#!/usr/local/bin/perl

###############################################
###                                                                                  
###                           dbSpace v1.5                                      
###                      Copyright Spaceout                          
###                  http://www.spaceout.com                            
###                                                                                 
###     This script may be used and modified freely      
###	         for non-profit or individual use                  
###       as long as this message remains intact.         
###   
###       Thank you Brent Michalski for some of the
###	       main routines written in this script.
###  Visit Brent's site at http://www.inlink.com/~perlguy/
###                                                                                  
###                       For commercial use             
###            there is a one time registration fee.            
###        http://www.spaceout.com/register.shtml       
### 
###     By using this code you agree to indemnify 
###    Spaceout or any of the scripts' authors from 
###       any liability that might arise from its use.   
###                                                                             
###############################################

use CGI qw (:standard);
use CGI::Carp qw(fatalsToBrowser);

###############################################
###                  Set Configurations Below                       
###############################################

### Specify your database fields in the array below 
@fields = ("Name","Address","City","State","Zip","Email","Phone","Fax","URL");

### Set URL and email fields to be hyperlinks 
### The number used corresponds to its placement in the array above 
### Remeber to start your count at zero
### Leave the variables empty to remove the hyperlink
$index_of_url = "8"; 	  
$index_of_email = "5";	  

### Specify the required fields below. This may be left empty 
@required = ("Name","Email");

### Specify the filtered words below.  This may be left empty 
@filter = ("word1","word2");

$database = "data.txt";			   # Data file name and path
$script_name = "dbspace.cgi";		   # This script name
$db_name = "dbSpace v1.5";	   	   # The database name
$table_width = "90%";		                  # The display width of the entire table
$record_width = "80%";			   # The display width of the database records
$max_rows_returned = "10";	  	   # Max number of rows displayed per page
$filter_html_tags = "yes";		  	   # Removes HTML tags from record entries
$user_file   = "users.txt";			   # User file name and path
$check_user_duplicates = "yes";		   # Checks for duplicate user names in user file
@extra_user_fields = ("Email");	   	   # Additional info needed when registering users
$use_external_html = "no";			   # Set to "yes" to use your own html template
$external_html_header = "header.html";             # File name and path to html template header
$external_html_footer = "footer.html";	   # File name and path to html template footer
$authenticate = "yes";			   # Prompts users for a user name and password
$register	= "yes";		 		   # Allows new user registration
$record_ownership = "yes";		   # Users can modify/delete only their records
$admin_user_name = "admin";		   # This is the default Administrator user name
$default_user_permission_search = "yes";	   # Gives newly registered users Search permission
$default_user_permission_add = "yes";	   # Gives newly registered users Add permission
$default_user_permission_modify = "no";          # Gives newly registered users Modify permission
$default_user_permission_delete = "no";           # Gives newly registered users Delete permission

###############################################
###            Change Nothing Below This Line                 
###############################################


############## Global Viariables ##################

$q = new CGI;
$field_count = @fields;
$colspan = $field_count+1;
$EXCLUSIVE = 2;
$UNLOCK    = 8;
$user = $q->param(user);
$user   = $q->cookie(user) if($user eq "");
$user_search = $q->param(user_search);
$user_search = "yes" if($authenticate eq "no");
$user_add = $q->param(user_add);
$user_add = "yes" if($authenticate eq "no");
$user_modify = $q->param(user_modify);
$user_modify = "yes" if($authenticate eq "no");
$user_delete = $q->param(user_delete);
$user_delete = "yes" if($authenticate eq "no");
$selected_user = $q->param(selected_user);
$admin_add = $q->param(admin_add);
$sort  = $q->param(sort_on);
$search_for   = $q->param(search_for);
$search_field = $q->param(search_field);
$action       = $q->param(action);
$display       = $q->param(display);
@keys         = $q->param(key);
$key         = $q->param(key);
$key_matches  = @keys;
$search_field = "all" if($search_field eq "");
$search_for   = '.'   if ($search_for eq "");
$action = $q->param(which_search) if($action =~ /^View/i);

################# Main Logic ##################

if($action =~ /add administrator/i){ &add_user; exit;}
if ($authenticate eq "yes"){ unless (-e $user_file){ $title="Set Administrative Password"; &create_admin; } }
if($register eq "yes" && $action =~ /register/i){ &register; exit;}
if($action =~ /add user/i){ &add_user; exit;}
if($action =~ /submit login/i){ &authenticate; exit;}
if ($authenticate eq "yes" && $user eq ""){ &login; exit;}
if($action =~ /logout/i){ &logout; exit;}

if($action =~ /add this record/i){ &add_record; $message="Record Added"; $title="Main Menu"; &print_default($title, $message);}
elsif($action =~ /add/i){ &print_add_screen;}
elsif($action =~ /modify record/i){ $title="Modification Error"; $error_message="You forgot to select a record to modify!"; &access_problem if($key < 1); &search_db($key);  &print_modify_page;}
elsif($action =~ /modify this record/i){ $title="Modify Record"; &delete_records; $key=$keys[0]; &add_record; $message="Record Modified"; $title="Main Menu"; &print_default($title, $message);}
elsif($action =~ /delete record/i){ $title="Delete Record"; $error_message="You forgot to select a record to delete!"; &access_problem if($key < 1); &delete_records; $message="Record Deleted"; $title="Main Menu"; &print_default($title, $message);}
elsif($action =~ /modify/i){ &search_db($search_for); $title="Modify Which Record?"; $button_text="Modify Record"; $choose="modify"; &search_results;}
elsif($action =~ /delete/i){ &search_db($search_for); $title="Delete Which Record?"; $button_text="Delete Record"; $choose="delete"; &search_results;}
elsif($action =~ /search/i){ &search_db($search_for); $title="Search Results"; $button_text = "";  $choose="search"; &search_results;}
elsif($action =~ /user manager/i){ $title="User Manager"; &user_manager;}
elsif($action =~ /create new user/i){ $title="User Manager - Create New User"; $perform="add"; $button_text ="Add User"; &edit_user;}
elsif($action =~ /edit selected user/i){ $title="User Manager - Edit Selected User"; $perform="edit"; $button_text ="Edit User"; &edit_user;}
elsif($action =~ /edit user/i){ $old_password = $q->param(old_password); &delete_user; $perform="edit"; &add_user;}
elsif($action =~ /remove selected user/i){ $perform="delete"; &delete_user; $title="User Manager"; &user_manager;}
 else { $title="Main Menu"; &print_default($title); }
exit;

################# Add Record ##################

sub add_record {
  foreach $required (@required){
  if($q->param($required) eq "") { 
  $title = "Add A Record"; $error_message = "You did not fill out the required information!"; &access_problem($error_message); exit; } }
  $when_added = &get_date;
  $key   = time();
  $record=$key;
  $record  .= "\|$user";
  $record  .= "\|$when_added";
  foreach $field (@fields){ ${$field}  = $q->param($field); ${$field}  = filter(${$field}); $record  .= "\|${$field}"; }
   unless (-e $database){ open (DB, ">$database") || die "Error creating database.  $!\n"; }
   else { open (DB, ">>$database") || die "Error opening database.  $!\n"; }
   flock DB, $EXCLUSIVE;
   seek DB, 0, 2;
   print DB "$record\n";
   flock DB, $UNLOCK;
  close(DB);
} # End of add_record subroutine.

############## Delete Records #################

sub delete_records
  {              
  open (DATABASE, "$database") or die "Error opening file: $!\n";
  while (<DATABASE>)
    {
    $line = $_;
    chop $line;
    @dbfields = split (/\|/, $line);
    $deleted = "no";
    if ($dbfields[0] eq $q->param(key)) { $deleted = "yes"; if ($user eq $dbfields[1]) { $security_satisfied = "yes"; } }
    elsif ($deleted ne "yes") { $new_data .= "$line\n"; }
    } #end of while
  close (DATABASE);
  if ($authenticate ne "yes") { $security_satisfied = "yes"; }
  if ($security_satisfied ne "yes" && $record_ownership eq "yes" && $admin_user_name ne "$user")
    {
    $error_message = "You're not authorized to access the record selected!";
    &access_problem($error_message);
    exit;
    }  else  {
    flock DATABASE, $EXCLUSIVE;
    open (DATABASE, ">$database") or die "Error opening file: $!\n";
    print DATABASE "$new_data";
    close (DATABASE);
    flock DATABASE, $UNLOCK;
    }
  } 

################# Add Screen ##################

sub print_add_screen{
$title="Add A Record";
&html_header($title);
  print<<HTML;
     <P>
      <TABLE BORDER=0 CELLSPACING=0>
HTML
  foreach $field (@fields){
       print<<HTML;
        <TR>
         <TD><B>\u$field:</B></TD>
         <TD><INPUT TYPE=TEXT NAME="$field"></TD>
        </TR>
HTML
  } # End of foreach.
      print<<HTML;
       <TR>
        <TD COLSPAN=2>
         <CENTER><BR>
          <INPUT TYPE=SUBMIT NAME=action VALUE="Add This Record">
         </CENTER>
        </TD>
       </TR>
      </TABLE>
     <P>
    </FONT>
HTML
&html_footer;
} # End of print_add_screen subroutine.

############### Modify Screen ################

sub print_modify_page{
  ($key,$dbuser,$when_added,@field_vals) = split(/\|/, $results[0]); 
$title="Modify Record";
&html_header($title);
  print<<HTML;
   <INPUT TYPE=HIDDEN NAME=key value="$key">
    <TABLE BORDER=0 CELLSPACING=0>
HTML
  $x=0;
  foreach $field (@fields){
    print<<HTML;
     <TR>
      <TD><FONT SIZE=2 FACE=ARIAL><B>\u$field:</B></FONT></TD>
      <TD><INPUT TYPE=TEXT NAME="$field" VALUE="$field_vals[$x]" SIZE=40></TD>
     </TR>
HTML
    $x++;
  } # End of foreach.
print<<HTML;
       	</TABLE>
	<BR>
        <INPUT TYPE=SUBMIT NAME=action VALUE="Modify This Record">
   <P>
HTML
&html_footer;
}

############## Results Screen ################

sub search_results{
&html_header($title);
  $rows_left_to_view = $total_row_count - $new_hits_seen;
  $start_hit = $hits_seen + 1;
  $end_hit = $new_hits_seen;
  $hits_displayed = $end_hit - $start_hit + 1;
  if ($total_row_count > 1) {
    print qq~<P><FONT SIZE=2 FACE=ARIAL>Total Found: <B>$total_row_count</B> records<BR>~;
    if ($total_row_count > $max_rows_returned) {
      if ($hits_displayed == 2) {  print qq~<B>Last two</B> records shown below<BR>~;  }
      elsif ($hits_displayed == 1) {  print qq~<B>Last</B> record shown below<BR>~;  }
      else { print qq~<B>$start_hit</B> - <B>$end_hit</B> shown below<BR>~;  }
    } #end if
  } #end if ... > 1
  else { print qq~<P><FONT SIZE=2 FACE=ARIAL>Total Found: <B>1</B> record\n~; }
if($display =~/columns/i) {
 print<<HTML;
	</FONT><p><TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH=$record_width>
    <TR BGCOLOR="#e0e0e0">
HTML
  if($choose =~ /(modify|delete)/){
    print "<TD ALIGN=CENTER><FONT SIZE=2 FACE=ARIAL><B>Select</B></FONT></TD>\n";
  }
  foreach $field (@fields){
    print "<TD ALIGN=CENTER><FONT SIZE=2 FACE=ARIAL><B>\u$field</B></FONT></TD>\n";
  } # End of foreach
  print "</TR>";
  foreach $record (@results){
    ($key,$dbuser,$when_added,@field_vals) = split(/\|/, $record); 
    print "<TR BGCOLOR=\"#efefef\">\n";
    if($choose =~ /(modify|delete)/){
       print "<TD ALIGN=CENTER><FONT SIZE=2 FACE=ARIAL><INPUT TYPE=RADIO NAME=key VALUE=$key></FONT></TD>\n";
    } # End of if.
      for($x=0;$x<$field_count;$x++){
      $item = &check_item($field_vals[$x], $x);
      print "<TD><FONT SIZE=2 FACE=ARIAL>$item</FONT></TD>\n";
    }
     print "</TR> ";
  } # End of foreach loop.
  print<<HTML;
</TR></TABLE>
HTML
} else {
  foreach $record (@results){
    ($key,$dbuser,$when_added,@field_vals) = split(/\|/, $record); 
 print<<HTML;
	<P><TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2 WIDTH=$record_width>
HTML
  if($choose =~ /(modify|delete)/){
    print "<TR BGCOLOR=\"\#e0e0e0\"><TD ALIGN=CENTER COLSPAN=2><FONT SIZE=2 FACE=ARIAL COLOR=RED><B>Select Record Below</B> <INPUT TYPE=RADIO NAME=key VALUE=$key></FONT></TD></TR>\n";
  }
  $x=0;
  foreach $field (@fields){
      $item = &check_item($field_vals[$x], $x);
    print<<HTML;
     <TR>
      <TD BGCOLOR="#e0e0e0"><B>\u$field</B></TD>
      <TD BGCOLOR="#efefef" WIDTH=100%>$item</TD>
     </TR>
HTML
    $x++;
 	 } # End of foreach field loop.
  print "</TABLE><P>";
  } # End of foreach record loop.
} # End of if display loop
if ($button_text ne ""){ print"<p><INPUT TYPE=submit NAME=action VALUE=\"$button_text\"><p>"; }
$which_search = $choose;
  if ($rows_left_to_view > 0 && $show ne "no") {
    print "<P><INPUT TYPE=\"hidden\" NAME=\"new_hits_seen\" VALUE=\"$new_hits_seen\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"which_search\" VALUE=\"$which_search\">";
    if ($rows_left_to_view > $max_rows_returned) { 
	print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"View Next $max_rows_returned Records\">"; } 
    elsif ($rows_left_to_view == 1){ 
	print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"View Last Record\">"; } 
    elsif ($rows_left_to_view <= $max_rows_returned){ 
	print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"View Last $rows_left_to_view Records\">"; } 
   } 
    print "<INPUT TYPE=\"hidden\" NAME=\"sort_on\" VALUE=\"$sort\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"display\" VALUE=\"$display\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"search_for\" VALUE=\"$search_for\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"search_field\" VALUE=\"$search_field\">\n";
print "<p>";
&html_footer;
} # End of search_results subroutine.

################ Default Screen ##################

sub print_default {
&html_header;
 print<<HTML;
  <TABLE BORDER=0 CELLSPACING="0" CELLPADDING="3"><TR><TD COLSPAN=3><FONT FACE="ARIAL" SIZE=2><B>Search 	For:</B></FONT><BR><INPUT TYPE="text" NAME="search_for" SIZE="40"></TD>
   </TR><TR> 
    <TD><FONT FACE="ARIAL" SIZE=2><B>Search By:</B></FONT><BR><SELECT NAME="search_field"><OPTION VALUE="all">All 
HTML
  $x=0;
  foreach $field (@fields){  print "<OPTION VALUE=$x>\u$field";  $x++;  }
  print<<HTML;
    </SELECT></FONT> </TD><TD><FONT FACE="ARIAL" SIZE=2><B>Sort By:</B></FONT><BR><SELECT NAME="sort_on">
HTML
  $x=0;
  foreach $field (@fields){  print "<OPTION VALUE=$x>\u$field";  $x++;  }
  print<<HTML;
</SELECT></TD>
	<TD><FONT FACE="ARIAL" SIZE=2><B>Display By:</B></FONT><BR><SELECT NAME="display">
HTML
if($display eq "rows") { print "<OPTION VALUE=\"rows\" SELECTED>Rows"; }
else { print "<OPTION VALUE=\"rows\">Rows"; }
if($display eq "columns") { print "<OPTION VALUE=\"columns\" SELECTED>Columns"; }
else { print "<OPTION VALUE=\"columns\">Columns"; }
  print<<HTML;
</SELECT></TD></TR></TABLE><br>
HTML
$footer="default";
&html_footer;
} # End of print_default subroutine.

########### Search & Sort Database #############

sub search_db{
  my $search_for = $_[0];
   unless (-e $database){ open (DB, ">$database") || die "Error creating database.  $!\n"; }
   else { open (DB, "$database") || die "Error opening database.  $!\n"; }
    while(<DB>){
      if($search_field =~ /all/i){
        if(/$search_for/oi){ push @results, $_};
      } else {
        ($key,$dbuser,$when_added,@field_vals) = split(/\|/, $_);
        if($field_vals[$search_field] =~ /$search_for/oi){ push @results, $_};
      } # End of else.
    } # End of while.
  close (DB);
  foreach $curr (@results){
    ($key,$dbuser,$when_added,@rest) = split(/\|/, $curr);
     $max = @fields;
     $code='$record{$key} = { key => "$key", ';
     $code .='dbuser => "$dbuser", ';
     $code .='when_added => "$when_added", ';
     for($x=0;$x<$max;$x++){
      $code .= "\$fields[$x] => \"\$rest[$x]\",\n";
    } # End of for
     $code .= '};';
    eval $code;
  } # End of foreach curr
   $sort_on = "$fields[$sort]";
   @results=();
  foreach $rp (sort { $a->{$sort_on} cmp $b->{$sort_on} } values %record){
    $new_rec = $rp->{key};
    $new_rec .= "\|$rp->{dbuser}";
    $new_rec .= "\|$rp->{when_added}";
    for($x=0;$x<$max;$x++){
      $new_rec .= "\|$rp->{$fields[$x]}";
    } # End of for
    push @results, $new_rec;
  } # End of foreach
$count = @results;
if($count < 1){ $message="No Matches Found For \"$search_for\""; $title="Main Menu"; &print_default($title, $message); exit;}
$total_row_count = @results;
if ($total_row_count > $max_rows_returned) {
$hits_seen = $q->param(new_hits_seen);
  for ($i = 1; $i <= $hits_seen; $i++)
    { $seen_row = shift (@results);  }
  $length_of_database_rows = @results;
  for ($i = $length_of_database_rows-1; $i >= $max_rows_returned; $i--)
    { $extra_row = pop (@results); }
  $new_hits_seen = $hits_seen + @results; } else { $show="no"; }
} # End of search_db subroutine.

################### Filter ####################

sub filter{
  $temp = $_[0];
  $temp =~ s/\|//g; 
  $temp =~ s/\"/'/g; 
  foreach $removed (@filter) { $temp =~ s/$removed/\?\$\%\&/gi; }
  if ($filter_html_tags eq "yes") { $temp =~ s/<[^>]*>//gs;  }
  return ($temp);
}

############### Check Item #################

sub check_item{
  $r_val = $_[0];
  $index = $_[1];
  if($r_val =~ /^\s*$/){$r_val="&nbsp;"; return($r_val);}
  if($index_of_url ne "" && $index eq $index_of_url) { 
  if ($r_val =~ /http:\/\//i){ $link = "$r_val"; }                        
  else { $link = "http://"; $link .= "$r_val";  }
  $r_val2 = "<a href=\"$link\">$r_val</a>"; $r_val = $r_val2; 
   }
  if($index_of_email ne "" && $index eq $index_of_email) { $r_val2 = "<a href=\"mailto:$r_val\">$r_val</a>"; $r_val = $r_val2; }
  return($r_val);
}

################### Login ###################

sub login {
$message = $_[0];
$title = "Login";
&html_header($title,$message);
 print<<HTML;
<TABLE><TR>
<TD><FONT SIZE=2 FACE="ARIAL"><B>User Name</B></FONT><BR><INPUT TYPE="text" NAME="user" SIZE="30"></TD></TR>
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Password</B></FONT><BR><INPUT TYPE="password" NAME="password" SIZE="30"></TD>
</TR>
<TR><TD ALIGN=MIDDLE><BR><INPUT TYPE="submit" NAME="action" VALUE="Submit Login">
HTML
if($register eq "yes") { print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Register\">"; }
print<<HTML;
</TD>
</TR>
</TABLE>
HTML
$footer = "login";
&html_footer;
}

################ Authenticate ################

sub authenticate {
    $form_password = $q->param(password);
    open (USERFILE, "$user_file") || die "Error opening user file.  $!\n";
    $user_matched = 0;
    while (<USERFILE>) {
	chop($_);
	($password, $user, $u_search, $u_add, $u_modify, $u_delete, @extra_user_fields) = split(/\|/, $_);
	if ($q->param(user) eq $user) {
	    $user_matched = 1;
	    $username = $user;
	    $user_add = $u_add;
	    $user_modify = $u_modify;
	    $user_search = $u_search;
	    $user_delete = $u_delete;
	if (&auth_encrypt ($form_password, $password) eq $password) {
  	    $cookie = cookie(-NAME=>'user',-VALUE=>"$user",-EXPIRES=>'+3d');
	} # End of if passwords match
	} # End of if username matches
    } # End of While
    close (USERFILE);
    if ($user_matched == 1 && $cookie eq "") {
	    $footer = "login";
	    $title = "Login";
	    $error_message = "Your password did not match your user name!";
	    &access_problem($error_message);
	    exit;    }
    if ($user_matched == 0) {
	    $footer = "login";
	    $title = "Login";
	    $error_message = "Your user name was not found!";
	    &access_problem($error_message);
	    exit;    }
print header(-cookie=>[$cookie]);
$set_cookie = "yes";
$message = "User \"$username\" is now logged in";
$title = "Main Menu"; 
$user = $username;
&print_default($title, $message);
exit;
}

############### Register Form ################

sub register {
$title = "Register A New User";
&html_header($title);
 print<<HTML;
<TABLE><TR>
<TD><FONT SIZE=2 FACE="ARIAL"><B>User Name</B></FONT><BR><INPUT TYPE="text" NAME="user" SIZE="30"></TD></TR>
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Password</B></FONT><BR><INPUT TYPE="password" NAME="password" SIZE="30"></TD></TR>
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Re-Type Password</B></FONT><BR><INPUT TYPE="password" NAME="password2" SIZE="30"></TD></TR>
HTML
  foreach $extra (@extra_user_fields){
    print "<TR><TD><FONT SIZE=2 FACE=\"ARIAL\"><B>\u$extra</B></FONT><BR><INPUT TYPE=\"text\" NAME=\"$extra\" SIZE=\"30\"></TD></TR>";
  }
 print<<HTML;
<TR><TD ALIGN=MIDDLE><BR><INPUT TYPE="hidden" NAME="search" value="$default_user_permission_search"><INPUT TYPE="hidden" NAME="add" value="$default_user_permission_add"><INPUT TYPE="hidden" NAME="modify" value="$default_user_permission_modify"><INPUT TYPE="hidden" NAME="delete" value="$default_user_permission_delete"><INPUT TYPE="submit" NAME="action" VALUE="Add User"> <INPUT TYPE="submit" NAME="action" VALUE="Back To Login"></TD>
</TR>
</TABLE>
HTML
$footer = "login";
&html_footer;
}

################ Add User ##################

sub add_user {
$user = $q->param(user);
$password = $q->param(password);
$password2 = $q->param(password2);
if ($perform eq "edit" && $password eq "") { $use_old = "yes"; $password = "$old_password"; $password2 = "$old_password";}
	if ($password ne $password2 || $password eq "" || $password2 eq "") {
	    $footer = "login";
	    $title = "Register A New User";
	    $error_message = "Your passwords didn't match!";
	    &access_problem($error_message);
	    exit;	}
@form_vars = ('user', 'search', 'add', 'modify', 'delete', @extra_user_fields);
    foreach $x (@form_vars) {
	if ($q->param($x) eq "" || $q->param($x) =~ /\|/) {
             $footer = "login";
	    $title = "Register A New User";
	    $error_message = "You must fill in all of the fields in the registration form!";
	    &access_problem($error_message);
	    exit;	}     }
    if ($check_user_duplicates eq "yes") {
	open (USERFILE, "$user_file");
	$user_matched = 0;
	while (<USERFILE>) {
	    chop($_);
	    @f = split(/\|/, $_);
	    if ($f[1] eq $user) {
		$user_matched = 1;
		last;	    }	} # End of while userfile open
	close (USERFILE);
	if ($user_matched == 1) {
	    $footer = "login";
	    $title = "Register A New User";
	    $error_message = "That user name is already taken!";
	    &access_problem($error_message);
	    exit;	} # End of user matched (found duplicate)    
	} # End of if check duplicates on
    srand(time|$$);
    $random = "abcdefghijklmnopqrstuvwxyz1234567890";
    $real_password = $password;
    $salt = "";
    for (1..2) { $salt .= substr($random,int(rand(36)),1); }
  if ($use_old ne "yes") {  $password = &auth_encrypt ($password, $salt); }
  $auth=$password;
  foreach $field (@form_vars){
    ${$field}  = $q->param($field);
    $auth   .= "\|${$field}";  }
   unless (-e $user_file){
    open (AUTH_FILE, ">$user_file") || die "Error creating user file.  $!\n";
  } else {
    open (AUTH_FILE, ">>$user_file") || die "Error opening user file.  $!\n";
  }
   flock AUTH_FILE, $EXCLUSIVE;
   seek AUTH_FILE, 0, 2;
   print AUTH_FILE "$auth\n";
   flock AUTH_FILE, $UNLOCK;
  close(AUTH_FILE);
if ($admin_add eq ""){
   $message = "New User Added<br>You may now login with your new user name below.";
   &login($message);
   } else { 
   $title = "User Manager";
   $message = "User Added/Modified";
   &user_manager($message);
   }
}

################ Create Admin ###############

sub create_admin{
&html_header($title);
 print<<HTML;
<center><TABLE WIDTH=275>
<TR>
<TD><FONT SIZE=2 FACE="ARIAL">Please start out by setting the Administrator information below.  When logged in as the below user, you will be able to access additional options which are only available to the database administrator.</FONT></TD>
</TR><TR>
<TD><br><FONT SIZE=2 FACE="ARIAL"><B>User Name:</B> $admin_user_name</FONT><br><font size="-2">This can be changed in the script configurations.</font></TD></TR>
<TR><TD><br><FONT SIZE=2 FACE="ARIAL"><B>Password</B></FONT><BR><INPUT TYPE="password" NAME="password" SIZE="30"></TD></TR>
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Re-Type Password</B></FONT><BR><INPUT TYPE="password" NAME="password2" SIZE="30"></TD></TR>
HTML
  foreach $extra (@extra_user_fields){
    print "<TR><TD><FONT SIZE=2 FACE=\"ARIAL\"><B>\u$extra</B></FONT><BR><INPUT TYPE=\"text\" NAME=\"$extra\" SIZE=\"30\"></TD></TR>";
  }
 print<<HTML;
<TR><TD ALIGN=MIDDLE><BR><INPUT TYPE="hidden" NAME="user" value="$admin_user_name"><INPUT TYPE="hidden" NAME="search" value="yes"><INPUT TYPE="hidden" NAME="add" value="yes"><INPUT TYPE="hidden" NAME="modify" value="yes"><INPUT TYPE="hidden" NAME="delete" value="yes"><INPUT TYPE="submit" NAME="action" VALUE="Add Administrator"></TD>
</TR>
</TABLE></center>
HTML
$footer = "login";
&html_footer;
exit;
}

################ User Manager ###############

sub user_manager{
$message = $_[0];
&html_header($title,$message);
 print<<HTML;
<center>
<TABLE>
<TR>
<TD><select name="selected_user" size=8>
HTML
    open (USERFILE, "$user_file") || die "Error opening user file.  $!\n";
    while (<USERFILE>) {
	chop($_);
	($password, $user, $u_search, $u_add, $u_modify, $u_delete, @extra_user_fields) = split(/\|/, $_);
	print "<option value=\"$user\">$user</option>\n";
    } # End of While
    close (USERFILE);
  print<<HTML;
</select></TD>
<td valign=top><input type=submit name=action value="Create New User"><p><input type=submit name=action value="Edit Selected User"><p><input type=submit name=action value="Remove Selected User">
</TR>
</TABLE>
</center>
HTML
&html_footer;
exit;
}

############### Add/Edit User ################

sub edit_user {
if ($perform eq "edit" && $selected_user eq "" ) {
	    $title = "User Manager - Edit Selected User";
	    $error_message = "You forgot to select a user record to edit!";
	    &access_problem($error_message);
	    exit;
}
if ($perform eq "edit") {
    open (USERFILE, "$user_file") || die "Error opening user file.  $!\n";
    while (<USERFILE>) {
	chop($_);
	($password, $userfound, $u_search, $u_add, $u_modify, $u_delete, @other_user_fields) = split(/\|/, $_);
	if ($selected_user eq $userfound) {
	    @found_other_fields = @other_user_fields;
	    $edit_user = $userfound;
	    $edit_user_add = $u_add;
	    $edit_user_modify = $u_modify;
	    $edit_user_search = $u_search;
	    $edit_user_delete = $u_delete;
	    $old_password = $password;
	} # End of if username matches
    } # End of While
    close (USERFILE);
}
&html_header($title);
 print<<HTML;
<TABLE><TR>
<TD><FONT SIZE=2 FACE="ARIAL"><B>User Name</B></FONT><BR><INPUT TYPE="text" NAME="user" SIZE="30" value="$edit_user"></TD></TR>
HTML
if ($perform eq "edit") {
  print<<HTML;
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>New Password</B></FONT><br><font size="-2">Leave blank if you aren't changing passwords.</font><BR><INPUT TYPE="password" NAME="password" SIZE="30"></TD></TR>
HTML
} else {
  print<<HTML;
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Password</B></FONT><BR><INPUT TYPE="password" NAME="password" SIZE="30"></TD></TR>
HTML
}
if ($perform eq "edit") {
  print<<HTML;
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Re-Type New Password</B></FONT><br><font size="-2">Leave blank if you aren't changing passwords.</font><BR><INPUT TYPE="password" NAME="password2" SIZE="30"></TD></TR>
HTML
} else {
  print<<HTML;
<TR><TD><FONT SIZE=2 FACE="ARIAL"><B>Re-Type Password</B></FONT><BR><INPUT TYPE="password" NAME="password2" SIZE="30"></TD></TR>
HTML
}
$extra_fields_count = @found_other_fields;
      for($x=0;$x<$extra_fields_count;$x++){
print "<TR><TD><FONT SIZE=2 FACE=\"ARIAL\"><B>\u$extra_user_fields[$x]</B></FONT><BR><INPUT TYPE=\"text\" NAME=\"$extra_user_fields[$x]\" SIZE=\"30\" value=\"$found_other_fields[$x]\"></TD></TR>";
    }
if ($perform eq "add") {
  foreach $extra (@extra_user_fields){
    print "<TR><TD><FONT SIZE=2 FACE=\"ARIAL\"><B>\u$extra</B></FONT><BR><INPUT TYPE=\"text\" NAME=\"$extra\" SIZE=\"30\"></TD></TR>";
  }
}
 print<<HTML;
<tr><td><br><FONT SIZE=2 FACE="ARIAL"><b>User Permissions</b></font></td></tr>
HTML

if ($edit_user_search eq "no"){
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Search: </font><input type="radio" name="search" value="yes"> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="search" value="no" checked> No</td></tr>
HTML
} else {
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Search: </font><input type="radio" name="search" value="yes" checked> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="search" value="no"> No</td></tr>
HTML
}
if ($edit_user_add eq "no"){
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Add: </font><input type="radio" name="add" value="yes"> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="add" value="no" checked> No</td></tr>
HTML
} else {
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Add: </font><input type="radio" name="add" value="yes" checked> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="add" value="no"> No</td></tr>
HTML
}
if ($edit_user_modify eq "no"){
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Modify: </font><input type="radio" name="modify" value="yes"> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="modify" value="no" checked> No</td></tr>
HTML
} else {
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Modify: </font><input type="radio" name="modify" value="yes" checked> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="modify" value="no"> No</td></tr>
HTML
}
if ($edit_user_delete eq "no"){
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Delete: </font><input type="radio" name="delete" value="yes"> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="delete" value="no" checked> No</td></tr>
HTML
} else {
  print<<HTML;
<tr><td><FONT SIZE=2 FACE="ARIAL">Delete: </font><input type="radio" name="delete" value="yes" checked> Yes &nbsp;&nbsp;&nbsp;<input type="radio" name="delete" value="no"> No</td></tr>
HTML
}
  print<<HTML;
<TR><TD ALIGN=MIDDLE><BR><input type=hidden name="old_password" value="$old_password"><input type=hidden name="selected_user" value="$edit_user"><input type=hidden name="admin_add" value="yes"><INPUT TYPE="submit" NAME="action" VALUE="$button_text"> <INPUT TYPE="submit" NAME="action" VALUE="User Manager"></TD>
</TR>
</TABLE>
HTML
&html_footer;
}

################ Delete User ###############

sub delete_user{
if ($selected_user eq "" ) {
	    $title = "User Manager - Remove Selected User";
	    $error_message = "You forgot to select a user record to remove!";
	    &access_problem($error_message);
	    exit;
}
if ($selected_user eq "$admin_user_name" && $perform eq "delete") {
	    $title = "User Manager - Remove Selected User";
	    $error_message = "You are not allowed to remove the administrator!";
	    &access_problem($error_message);
	    exit;
}
  open (USERFILE, "$user_file") or die "Error opening file: $!\n";
  while (<USERFILE>)
    {
    $line = $_;
    chop $line;
    @dbfields = split (/\|/, $line);
    $deleted = "no";
    if ($dbfields[1] eq $selected_user) { $deleted = "yes"; }
    elsif ($deleted ne "yes") { $new_data .= "$line\n"; }
    } #end of while
  close (USERFILE);
    flock USERFILE, $EXCLUSIVE;
    open (USERFILE, ">$user_file") or die "Error opening file: $!\n";
    print USERFILE "$new_data";
    close (USERFILE);
}

################# Logout ###################

sub logout {
$cookie = cookie(-NAME=>'user',-VALUE=>"$user",-EXPIRES=>'-1d');
print header(-cookie=>[$cookie]);
$set_cookie = "yes";
$message = "User \"$user\" logged out";
&login($message);
 } # end of logout

############ Encrypt Password ###############

sub auth_encrypt {
    local ($field, $salt) = @_;
    $field = crypt ($field, $salt);
    $field;
 } # end of encrypt

############## Access Problem ##############

sub access_problem {
&html_header($title);
 print<<HTML;
<BR>
<FONT SIZE=4 FACE="ARIAL" COLOR=RED><B>Error!</B></FONT><P>
<FONT SIZE=4 FACE="ARIAL">$error_message</FONT><P>
<INPUT TYPE="button" VALUE="  Back  " onClick="history.go(-1)"><br><br>
HTML
&html_footer;
exit;
}

################ Get Date ##################

sub get_date  {
  local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$date);   
  local (@days, @months);
  @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
  @months = ('January','February','March','April','May','June','July','August','September','October','November','December');
  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  if ($hour < 10)    {    $hour = "0$hour";    }
  if ($min < 10)     {    $min = "0$min";    }
  if ($sec < 10)    { $sec = "0$sec";    }
  $mon++;
 $year += 1900;
 $date = "$mon/$mday/$year at $hour\:$min\:$sec";
  return $date;
  }

############## Form Header #################

sub form_header {
print<<HTML;
<FORM METHOD="post" ACTION="$script_name">
HTML
}

############## Form Footer #################

sub form_footer {
if($footer eq "default") {
if ($user_search eq "yes") {print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Search\"> "; }
if ($user_add eq "yes") {print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"  Add  \"> "; }
if ($user_modify eq "yes") {print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Modify\"> "; }
if ($user_delete eq "yes") {print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Delete\"> "; }
if ($authenticate eq "yes") { print " <INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Logout\">\n"; }
}
elsif($footer eq "login") { print "\&nbsp\;"; }
 else { print "<INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Main Menu\">"; if ($authenticate eq "yes") { print " <INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Logout\">";} }
print "<input type=hidden name=\"user_search\" value=\"$user_search\">\n";
print "<input type=hidden name=\"user_add\" value=\"$user_add\">\n";
print "<input type=hidden name=\"user_modify\" value=\"$user_modify\">\n";
print "<input type=hidden name=\"user_delete\" value=\"$user_delete\">\n";
}

############## HTML Header #################

sub html_header{
if($set_cookie eq "") { print $q->header; }
$set_cookie = "";
if($use_external_html eq "yes") { 
%external_variables = (title=>$title, message=>$message,);
print html_template("$external_html_header", \%external_variables); 
&form_header;
} else {
 print<<HTML;
<HTML><HEAD>
   <TITLE>$db_name - $_[0]</TITLE>
  </HEAD><BODY BGCOLOR="#FFFFFF">
  <CENTER><FONT SIZE=5 FACE="ARIAL"><B>
   $db_name
  </B></FONT><p><FONT SIZE=3 FACE="ARIAL" COLOR=RED><B>$_[1]</B></FONT></CENTER><P>
   <CENTER>
   <TABLE BORDER=1 WIDTH="$table_width" CELLSPACING="0" CELLPADDING="3">
    <TR> 
    <TD BGCOLOR="#e0e0e0"> 
     <CENTER> 
          <FONT SIZE=3 FACE="ARIAL"><B>$_[0]</B></FONT>
     </CENTER>
    </TD>
   </TR>
    <TR> 
     <TD align=middle><BR>
HTML
&form_header;
}
}

############## HTML Footer #################

sub html_footer{
if($use_external_html eq "yes") { 
%external_variables = (title=>$title, message=>$message,);
&form_footer;
print html_template("$external_html_footer", \%external_variables); 
if ($user eq "$admin_user_name" && $footer eq "default" && $authenticate eq "yes") {
print "<center><input type=\"submit\" name=\"action\" value=\"User Manager\"></center><p>";
}
print "<center><FONT SIZE=-2 FACE=ARIAL><p>Powered by <a href=\"http://www.spaceout.com/dbspace\">dbSpace</a><br>\&copy\; Spaceout<br><br></font></center>";
} else {
 print<<HTML;
    <BR></TD></TR>
  <TR> 
    <TD BGCOLOR="#e0e0e0"><CENTER> 
HTML
&form_footer;
 print<<HTML;
     </CENTER>
    </TD>
  </TR>
</TABLE><P>
HTML
if ($user eq "$admin_user_name" && $footer eq "default" && $authenticate eq "yes") {
print "<center><input type=\"submit\" name=\"action\" value=\"User Manager\"></center><p>";
}
  print<<HTML;
<center><FONT SIZE=-2 FACE=ARIAL><p>Powered by <a href=\"http://www.spaceout.com/dbspace\">dbSpace</a><br>\&copy\; Spaceout<br><br></font></center>
</FORM>
 </CENTER>
</BODY></HTML>
HTML
	}
}

############ Use External HTML ###########################
##  Thank you Tom Christiansen & Nathan Torkington for this routine
##  Taken from the Perl Cookbook

sub html_template {
my ($filename, $fillings) = @_;
my $text;
local $/;
local *F;
open (F, "< $filename\0") || return;
$text = <F>;
close (F);
$text =~ s{%%( .*? )%%}
	   {exists($fillings->{$1})
		   ?$fillings->{$1}
		   : ""
	   }gsex;
return $text;
}
